﻿using System;
using System.Collections.Generic;
using System.Text;
using Telerik.WinControls.UI;
using Telerik.WinControls;
using Telerik.WinControls.Design;
using System.ComponentModel;

namespace CustomControls
{
    [Telerik.WinControls.Themes.Design.RadThemeDesignerData(typeof(CustomTextBoxDesignTimeData))]
    public class CustomTextBox : RadTextBox
    {
        private bool textElementInitialized = false;

        [RadDefaultValue("ErrorState", typeof(CustomTextBoxElement))]
        [Category("Behavior")]
        public ErrorState ErrorState
        {
            get
            {
                this.EnsureChildItems();
                return ((CustomTextBoxElement)this.TextBoxElement).ErrorState;
            }
            set
            {
                this.EnsureChildItems();
                ((CustomTextBoxElement)this.TextBoxElement).ErrorState = value;
            }
        }

        protected override void InitializeTextElement()
        {
            if (this.textElementInitialized)
            {
                return;
            }
            this.textBoxElement = new CustomTextBoxElement();
            this.textBoxElement.ShowBorder = true;
            this.textElementInitialized = true;
        }
    }
}
