﻿using System;
using System.Collections.Generic;
using System.Text;
using Telerik.WinControls.Themes.Design;

namespace CustomControls
{
    public class CustomTextBoxDesignTimeData : RadControlDesignTimeData
    {
        public CustomTextBoxDesignTimeData()
        { }

        public CustomTextBoxDesignTimeData(string name)
            : base(name)
        { }


        /// <summary>
        /// Initializes the controls which will appear in the VSBuilder
        /// </summary>
        /// <param name="previewSurface"></param>
        /// <returns></returns>
        public override ControlStyleBuilderInfoList GetThemeDesignedControls(System.Windows.Forms.Control previewSurface)
        {
            CustomTextBox textbox = new CustomTextBox();
            textbox.Text = "CustomTextBox";
            textbox.Bounds = new System.Drawing.Rectangle(0, 0, 100, 15);

            CustomTextBox textboxStructure = new CustomTextBox();
            textboxStructure.Bounds = new System.Drawing.Rectangle(0, 0, 100, 15);
            textboxStructure.Text = "CustomTextBox";

            ControlStyleBuilderInfo designed = new ControlStyleBuilderInfo(textbox, textboxStructure.RootElement);
            designed.MainElementClassName = typeof(CustomTextBoxElement).FullName;
            designed.Placemenet = PreviewControlPlacemenet.MiddleCenter;

            ControlStyleBuilderInfoList res = new ControlStyleBuilderInfoList();
            res.Add(designed);
            return res;
        }
    }
}
