﻿using System;
using System.Collections.Generic;
using System.Text;
using Telerik.WinControls.UI;
using Telerik.WinControls;
using Telerik.WinControls.Design;
using System.ComponentModel;
using System.Drawing;
using Telerik.WinControls.Primitives;

namespace CustomControls
{
    public class CustomTextBoxElement : RadTextBoxElement
    {
        public static readonly RadProperty ErrorStateProperty = RadProperty.Register(
            "ErrorState", typeof(ErrorState), typeof(CustomTextBoxElement),
            new RadElementPropertyMetadata(ErrorState.NoError, ElementPropertyOptions.AffectsDisplay));

        static CustomTextBoxElement()
        {
            ThemeResolutionService.RegisterThemeFromStorage(ThemeStorageType.Resource,
                "CustomControls.CustomTextBoxDefault.xml");
        }

        [RadPropertyDefaultValue("ErrorState", typeof(CustomTextBoxElement))]
        [Category("Behavior")]
        public ErrorState ErrorState
        {
            get
            {
                return (ErrorState)this.GetValue(ErrorStateProperty);
            }
            set
            {
                this.SetValue(ErrorStateProperty, value);
            }
        }

        protected override void OnPropertyChanged(RadPropertyChangedEventArgs e)
        {
            base.OnPropertyChanged(e);
            if (e.Property == VisualElement.BackColorProperty)
            {
                Color newBackColor = (Color)e.NewValue;
                this.TextBoxItem.BackColor = newBackColor;
                FillPrimitive fillPrimitive = (FillPrimitive)this.Children[1];
                fillPrimitive.BackColor = newBackColor;
            }
        }
    }
}
